#ifndef __DEBUG_HPP__
#define __DEBUG_HPP__

#include <stdexcept>
#include <cassert>

///////////////////////////////////////////////////////////////////////////////
// Design by contract macros
///////////////////////////////////////////////////////////////////////////////
# if defined(NDEBUG)
#   define require(expr)    {if(!(expr))throw std::runtime_error("precondition failed: "  #expr " in " __FILE__);}
#   define ensure(expr)     {if(!(expr))throw std::runtime_error("postcondition failed: " #expr " in " __FILE__);}
#   define invariant(expr)  {if(!(expr))throw std::runtime_error("invariant failed: "     #expr " in " __FILE__);}
#   define check(expr)      {if(!(expr))throw std::runtime_error("assertion failed: "     #expr " in " __FILE__);}
# else
#   define require(expr)    assert(expr)
#   define ensure(expr)     assert(expr)
#   define invariant(expr)  assert(expr)
#   define check(expr)      assert(expr)
# endif


#endif