#ifndef __NULLSTREAM_HPP__
#define __NULLSTREAM_HPP__

#include <iostream>

///////////////////////////////////////////////////////////////////////////////
//  nullstream
///////////////////////////////////////////////////////////////////////////////
class nullstream : public std::ostream {
  

  class nullstreambuf : public std::streambuf {
  public:
    int   out_waiting()                  { return 0; }
    int   sputc( int c )                 { return c; }
    int   sputn( const char*, int n )    { return n; }
  };

public:
  nullstream();
  
  virtual  std::ostream &put( char )
  { 
    return *this; 
  }
  
  virtual  std::ostream &put( signed char )
  { 
    return *this; 
  }
  
  virtual  std::ostream &put( unsigned char )
  { 
    return *this; 
  }
  
  virtual  std::ostream &seekp( std::streampos )
  { 
    return *this; 
  }

  virtual  std::ostream &seekp( std::streamoff, seek_dir )
  { 
    return *this; 
  }
  
  virtual  std::streampos tellp()
  { 
    return std::streampos(0); 
  }
  
  virtual  std::ostream &write( const char*, int )
  { 
    return *this; 
  }

  virtual  std::ostream &write( const signed char*, int )
  { 
    return *this; 
  }

  virtual  std::ostream &write( const unsigned char*, int )
  { 
    return *this; 
  }

};


#endif